/*
2018년도 2학기 의료영상처리 실습프로그램 main class
 */
package main;

import Listeners.ComboBoxListener;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.FlowLayout;
import java.awt.List;
import java.awt.event.ActionEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.zip.ZipEntry;
import java.util.zip.ZipInputStream;
import javax.imageio.ImageIO;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

/*
 * @author pjkim
 */
public class IP_2018_main extends JFrame
{
    static public xImage currentImage = null;
    //main 함수
    public static void main(String[] args) 
    {
        (new IP_2018_main()).setVisible(true);  
    }
    //--------------------------------------------------------------------
    //생성자
    IP_2018_main()
    {
        setTitle("2018-2학기 의료영상처리");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        //setSize(500, 30);
        setResizable(false);
        //setLayout(new GridLayout(1, 3, 10, 0));
        getContentPane().setBackground(Color.WHITE);
        setLayout(new FlowLayout());

        JButton imageBtn  = new JButton("Image");
        
        imageBtn.addActionListener( 
                (ActionEvent e) -> { 
                    xImage ximg = loadImage();
                    if(ximg != null) {
                        new ImageFrame(ximg).setVisible(true);
                    }
                }
        );
        
        imageBtn.setPreferredSize(new Dimension(120, 30));
 
        add(imageBtn); 
        
        JComboBox<String> pluginBox = new JComboBox<>();

        ((JLabel)pluginBox.getRenderer()).setHorizontalAlignment(JLabel.CENTER);
        
        pluginBox.addItem("Plugins");  //콤보박스의 첫번째 item이자 콤보박스의 제목
        
        try {
            ClassLoader classLoader = Thread.currentThread().getContextClassLoader();
            URL url = classLoader.getResource("plugins");
             String filePath = url.getFile();

             if (filePath.startsWith("file:") && filePath.contains("!")) {

                //String[] split = filePath.split("!");
                //URL jar = new URL(split[0]);
                
                int indx = filePath.indexOf('!');
                if(indx > 0) filePath=filePath.substring(0, indx);
                URL jar = new URL(filePath);

                ZipInputStream zip = new ZipInputStream(jar.openStream());
                ZipEntry entry;

                while ((entry = zip.getNextEntry()) != null) {
                    String className = entry.getName();
                    
                    if (className.endsWith(".class")) {
                        className = className.replaceAll("[$].*", "").replaceAll("[.]class", "").replace('/', '.');         
                        if (className.startsWith("plugins") ) {
                              int index = className.indexOf('.');
                              if(index > 0) className=className.substring(index+1, className.length());
                              pluginBox.addItem(className);
                        }//if plugins
                    }//if .class
                }//while
            }
            else {  // else   Jar파일이 아니고 프로그램이 개발환경 안에서 실행될 경우
                //File folder = new File("build/classes/plugins");
                File folder = new File(filePath);
                File[] listOfFiles = folder.listFiles();

                for (int i = 0; i < listOfFiles.length; i++) {
                    if (listOfFiles[i].isFile()) {
                        String filename = listOfFiles[i].getName();
                        int index = filename.indexOf('.');
                        if(index > 0) filename=filename.substring(0, index);
                        pluginBox.addItem(filename);
                    }//if
                }//for
             }//else

        }//try
        catch(Exception ex) {
            System.out.println("No plugin Found..");
        }
        
        pluginBox.setPreferredSize(new Dimension(150, 30));
        
        pluginBox.addActionListener(new ComboBoxListener(this));
        
        add(pluginBox);
        
//        JButton closeBtn = new JButton("Close");
//        
//        closeBtn.setPreferredSize(new Dimension(120, 30));
//        
//        closeBtn.addActionListener ((ActionEvent e) -> { setVisible(false); dispose(); System.exit(0); });
//           
//        add(closeBtn);
        
        pack();
        
        //setVisible(true);
    }
    
    //-------------------------------------------------------------
    private xImage loadImage()
    {
        xImage ximg = new xImage();
        
        FileDialog fd = new FileDialog(this, "Open a Image File", FileDialog.LOAD);
        fd.setFile("*.jpg; *.jpeg; *.png; *.tiff; *.gif; *.bmp; *.pbm; *.dcm");
        fd.setVisible(true);

        if(fd.getFile() == null) return null;
        
        ximg.filePath = fd.getDirectory();
        ximg.fileName = fd.getFile();
        String fileName =  ximg.filePath + ximg.fileName;
    
        try {
            ximg.img = ImageIO.read(new File(fileName) );
            ximg.width = ximg.img.getWidth();
            ximg.height = ximg.img.getHeight();
            ximg.type = ximg.img.getType();
            ximg.title = ximg.fileName + " (" + ximg.width + "x" + ximg.height + ") ";
        } 
        catch (Exception ex) {
            //Logger.getLogger(Resources.class.getName()).log(Level.SEVERE, null, ex);
            System.out.println("Image load Error: " + fileName);
            return null;
        }
        
        System.out.println(ximg.img.getType());
        
        switch(ximg.img.getType())
        {
            case BufferedImage.TYPE_3BYTE_BGR:  System.out.println("TYPE_3BYTE_BGR"); break;
            case BufferedImage.TYPE_4BYTE_ABGR: System.out.println("TYPE_4BYTE_ABGR"); break;
            case BufferedImage.TYPE_4BYTE_ABGR_PRE: System.out.println("TYPE_4BYTE_ABGR_PRE"); break;
            case BufferedImage.TYPE_BYTE_GRAY: System.out.println("TYPE_BYTE_GRAY"); break;
            case BufferedImage.TYPE_BYTE_INDEXED: System.out.println("TYPE_BYTE_INDEXED"); break;
            case BufferedImage.TYPE_CUSTOM: System.out.println("TYPE_CUSTOM"); break;
            case BufferedImage.TYPE_INT_ARGB: System.out.println("TYPE_INT_ARGB"); break;
            case BufferedImage.TYPE_INT_ARGB_PRE: System.out.println("TYPE_INT_ARGB_PRE"); break;
            case BufferedImage.TYPE_INT_BGR: System.out.println("TYPE_INT_BGR"); break;
            case BufferedImage.TYPE_INT_RGB: System.out.println("TYPE_INT_RGB"); break;
            case BufferedImage.TYPE_USHORT_555_RGB: System.out.println("TYPE_USHORT_555_RGB"); break;
            case BufferedImage.TYPE_USHORT_565_RGB: System.out.println("TYPE_USHORT_565_RGB"); break;
            case BufferedImage.TYPE_USHORT_GRAY: System.out.println("TYPE_USHORT_GRAY"); break;
            
            default: System.out.println("Unknown Image type..");

        }
        return ximg;
    }

    
    
}
