
package plugins;

import main.ImageFrame;
import main.ImagePlugin;
import main.xImage;

/**
 * @author pjkim
 */
public class Inverse implements ImagePlugin
{
    @Override
    public void runPlugin(xImage ximg)
    {
        if(ximg==null) {
            System.out.println("image is NULL");
            return;
        }
        
        System.out.println(ximg.title + " Inverting..");
        
        xImage newImg = ximg.copyEmptyImage("Inv-");
        
        for(int x = 0; x < newImg.width; x++) {
           for(int y=0; y<newImg.height ; y++) {
               
               int color = ximg.img.getRGB(x, y);
               int red    = (color >> 16) & 0xff;
               int green = (color >> 8)  & 0xff;
               int blue   = (color >> 0)  & 0xff;
               
               red    = (~red)    & 0xff;
               green = (~green) & 0xff;
               blue   = (~blue)   & 0xff;

//               red = 255 - red;
//               green = 255 - green;
//               blue = 255 - blue;
              
              int newColor = 0xff000000 |  (red << 16)  | (green << 8) | blue;
             
               newImg.img.setRGB(x,y,newColor); 
              
           }//for y
       }//for x
       
        new ImageFrame(newImg).setVisible(true);
                
    }
}
